// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Visible string status (VSS)
 * </pre>
 *
 * Protobuf type {@code commonmodule.VSS}
 */
public final class VSS extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.VSS)
    VSSOrBuilder {
private static final long serialVersionUID = 0L;
  // Use VSS.newBuilder() to construct.
  private VSS(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private VSS() {
    stVal_ = "";
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new VSS();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_VSS_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_VSS_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.VSS.class, openfmb.commonmodule.VSS.Builder.class);
  }

  public static final int Q_FIELD_NUMBER = 1;
  private openfmb.commonmodule.Quality q_;
  /**
   * <pre>
   * Quality of the value in 'stVal'.
   * </pre>
   *
   * <code>.commonmodule.Quality q = 1;</code>
   * @return Whether the q field is set.
   */
  @java.lang.Override
  public boolean hasQ() {
    return q_ != null;
  }
  /**
   * <pre>
   * Quality of the value in 'stVal'.
   * </pre>
   *
   * <code>.commonmodule.Quality q = 1;</code>
   * @return The q.
   */
  @java.lang.Override
  public openfmb.commonmodule.Quality getQ() {
    return q_ == null ? openfmb.commonmodule.Quality.getDefaultInstance() : q_;
  }
  /**
   * <pre>
   * Quality of the value in 'stVal'.
   * </pre>
   *
   * <code>.commonmodule.Quality q = 1;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.QualityOrBuilder getQOrBuilder() {
    return q_ == null ? openfmb.commonmodule.Quality.getDefaultInstance() : q_;
  }

  public static final int STVAL_FIELD_NUMBER = 2;
  @SuppressWarnings("serial")
  private volatile java.lang.Object stVal_ = "";
  /**
   * <pre>
   * Value of the data.
   * </pre>
   *
   * <code>string stVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The stVal.
   */
  @java.lang.Override
  public java.lang.String getStVal() {
    java.lang.Object ref = stVal_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      stVal_ = s;
      return s;
    }
  }
  /**
   * <pre>
   * Value of the data.
   * </pre>
   *
   * <code>string stVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The bytes for stVal.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getStValBytes() {
    java.lang.Object ref = stVal_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      stVal_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int T_FIELD_NUMBER = 3;
  private openfmb.commonmodule.Timestamp t_;
  /**
   * <pre>
   * Timestamp of the last change of the value in any of 'stVal' or 'q'.
   * </pre>
   *
   * <code>.commonmodule.Timestamp t = 3;</code>
   * @return Whether the t field is set.
   */
  @java.lang.Override
  public boolean hasT() {
    return t_ != null;
  }
  /**
   * <pre>
   * Timestamp of the last change of the value in any of 'stVal' or 'q'.
   * </pre>
   *
   * <code>.commonmodule.Timestamp t = 3;</code>
   * @return The t.
   */
  @java.lang.Override
  public openfmb.commonmodule.Timestamp getT() {
    return t_ == null ? openfmb.commonmodule.Timestamp.getDefaultInstance() : t_;
  }
  /**
   * <pre>
   * Timestamp of the last change of the value in any of 'stVal' or 'q'.
   * </pre>
   *
   * <code>.commonmodule.Timestamp t = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.TimestampOrBuilder getTOrBuilder() {
    return t_ == null ? openfmb.commonmodule.Timestamp.getDefaultInstance() : t_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (q_ != null) {
      output.writeMessage(1, getQ());
    }
    if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(stVal_)) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 2, stVal_);
    }
    if (t_ != null) {
      output.writeMessage(3, getT());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (q_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getQ());
    }
    if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(stVal_)) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, stVal_);
    }
    if (t_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getT());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.VSS)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.VSS other = (openfmb.commonmodule.VSS) obj;

    if (hasQ() != other.hasQ()) return false;
    if (hasQ()) {
      if (!getQ()
          .equals(other.getQ())) return false;
    }
    if (!getStVal()
        .equals(other.getStVal())) return false;
    if (hasT() != other.hasT()) return false;
    if (hasT()) {
      if (!getT()
          .equals(other.getT())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasQ()) {
      hash = (37 * hash) + Q_FIELD_NUMBER;
      hash = (53 * hash) + getQ().hashCode();
    }
    hash = (37 * hash) + STVAL_FIELD_NUMBER;
    hash = (53 * hash) + getStVal().hashCode();
    if (hasT()) {
      hash = (37 * hash) + T_FIELD_NUMBER;
      hash = (53 * hash) + getT().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.VSS parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.VSS parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.VSS parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.VSS parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.VSS parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.VSS parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.VSS parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.VSS parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.VSS parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.VSS parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.VSS parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.VSS parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.VSS prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Visible string status (VSS)
   * </pre>
   *
   * Protobuf type {@code commonmodule.VSS}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.VSS)
      openfmb.commonmodule.VSSOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_VSS_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_VSS_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.VSS.class, openfmb.commonmodule.VSS.Builder.class);
    }

    // Construct using openfmb.commonmodule.VSS.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      q_ = null;
      if (qBuilder_ != null) {
        qBuilder_.dispose();
        qBuilder_ = null;
      }
      stVal_ = "";
      t_ = null;
      if (tBuilder_ != null) {
        tBuilder_.dispose();
        tBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_VSS_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.VSS getDefaultInstanceForType() {
      return openfmb.commonmodule.VSS.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.VSS build() {
      openfmb.commonmodule.VSS result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.VSS buildPartial() {
      openfmb.commonmodule.VSS result = new openfmb.commonmodule.VSS(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.VSS result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.q_ = qBuilder_ == null
            ? q_
            : qBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.stVal_ = stVal_;
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.t_ = tBuilder_ == null
            ? t_
            : tBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.VSS) {
        return mergeFrom((openfmb.commonmodule.VSS)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.VSS other) {
      if (other == openfmb.commonmodule.VSS.getDefaultInstance()) return this;
      if (other.hasQ()) {
        mergeQ(other.getQ());
      }
      if (!other.getStVal().isEmpty()) {
        stVal_ = other.stVal_;
        bitField0_ |= 0x00000002;
        onChanged();
      }
      if (other.hasT()) {
        mergeT(other.getT());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getQFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              stVal_ = input.readStringRequireUtf8();
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getTFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.Quality q_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Quality, openfmb.commonmodule.Quality.Builder, openfmb.commonmodule.QualityOrBuilder> qBuilder_;
    /**
     * <pre>
     * Quality of the value in 'stVal'.
     * </pre>
     *
     * <code>.commonmodule.Quality q = 1;</code>
     * @return Whether the q field is set.
     */
    public boolean hasQ() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * Quality of the value in 'stVal'.
     * </pre>
     *
     * <code>.commonmodule.Quality q = 1;</code>
     * @return The q.
     */
    public openfmb.commonmodule.Quality getQ() {
      if (qBuilder_ == null) {
        return q_ == null ? openfmb.commonmodule.Quality.getDefaultInstance() : q_;
      } else {
        return qBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Quality of the value in 'stVal'.
     * </pre>
     *
     * <code>.commonmodule.Quality q = 1;</code>
     */
    public Builder setQ(openfmb.commonmodule.Quality value) {
      if (qBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        q_ = value;
      } else {
        qBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Quality of the value in 'stVal'.
     * </pre>
     *
     * <code>.commonmodule.Quality q = 1;</code>
     */
    public Builder setQ(
        openfmb.commonmodule.Quality.Builder builderForValue) {
      if (qBuilder_ == null) {
        q_ = builderForValue.build();
      } else {
        qBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Quality of the value in 'stVal'.
     * </pre>
     *
     * <code>.commonmodule.Quality q = 1;</code>
     */
    public Builder mergeQ(openfmb.commonmodule.Quality value) {
      if (qBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          q_ != null &&
          q_ != openfmb.commonmodule.Quality.getDefaultInstance()) {
          getQBuilder().mergeFrom(value);
        } else {
          q_ = value;
        }
      } else {
        qBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Quality of the value in 'stVal'.
     * </pre>
     *
     * <code>.commonmodule.Quality q = 1;</code>
     */
    public Builder clearQ() {
      bitField0_ = (bitField0_ & ~0x00000001);
      q_ = null;
      if (qBuilder_ != null) {
        qBuilder_.dispose();
        qBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Quality of the value in 'stVal'.
     * </pre>
     *
     * <code>.commonmodule.Quality q = 1;</code>
     */
    public openfmb.commonmodule.Quality.Builder getQBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getQFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Quality of the value in 'stVal'.
     * </pre>
     *
     * <code>.commonmodule.Quality q = 1;</code>
     */
    public openfmb.commonmodule.QualityOrBuilder getQOrBuilder() {
      if (qBuilder_ != null) {
        return qBuilder_.getMessageOrBuilder();
      } else {
        return q_ == null ?
            openfmb.commonmodule.Quality.getDefaultInstance() : q_;
      }
    }
    /**
     * <pre>
     * Quality of the value in 'stVal'.
     * </pre>
     *
     * <code>.commonmodule.Quality q = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Quality, openfmb.commonmodule.Quality.Builder, openfmb.commonmodule.QualityOrBuilder> 
        getQFieldBuilder() {
      if (qBuilder_ == null) {
        qBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Quality, openfmb.commonmodule.Quality.Builder, openfmb.commonmodule.QualityOrBuilder>(
                getQ(),
                getParentForChildren(),
                isClean());
        q_ = null;
      }
      return qBuilder_;
    }

    private java.lang.Object stVal_ = "";
    /**
     * <pre>
     * Value of the data.
     * </pre>
     *
     * <code>string stVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The stVal.
     */
    public java.lang.String getStVal() {
      java.lang.Object ref = stVal_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        stVal_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <pre>
     * Value of the data.
     * </pre>
     *
     * <code>string stVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The bytes for stVal.
     */
    public com.google.protobuf.ByteString
        getStValBytes() {
      java.lang.Object ref = stVal_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        stVal_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <pre>
     * Value of the data.
     * </pre>
     *
     * <code>string stVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The stVal to set.
     * @return This builder for chaining.
     */
    public Builder setStVal(
        java.lang.String value) {
      if (value == null) { throw new NullPointerException(); }
      stVal_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of the data.
     * </pre>
     *
     * <code>string stVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearStVal() {
      stVal_ = getDefaultInstance().getStVal();
      bitField0_ = (bitField0_ & ~0x00000002);
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value of the data.
     * </pre>
     *
     * <code>string stVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The bytes for stVal to set.
     * @return This builder for chaining.
     */
    public Builder setStValBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) { throw new NullPointerException(); }
      checkByteStringIsUtf8(value);
      stVal_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }

    private openfmb.commonmodule.Timestamp t_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Timestamp, openfmb.commonmodule.Timestamp.Builder, openfmb.commonmodule.TimestampOrBuilder> tBuilder_;
    /**
     * <pre>
     * Timestamp of the last change of the value in any of 'stVal' or 'q'.
     * </pre>
     *
     * <code>.commonmodule.Timestamp t = 3;</code>
     * @return Whether the t field is set.
     */
    public boolean hasT() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Timestamp of the last change of the value in any of 'stVal' or 'q'.
     * </pre>
     *
     * <code>.commonmodule.Timestamp t = 3;</code>
     * @return The t.
     */
    public openfmb.commonmodule.Timestamp getT() {
      if (tBuilder_ == null) {
        return t_ == null ? openfmb.commonmodule.Timestamp.getDefaultInstance() : t_;
      } else {
        return tBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Timestamp of the last change of the value in any of 'stVal' or 'q'.
     * </pre>
     *
     * <code>.commonmodule.Timestamp t = 3;</code>
     */
    public Builder setT(openfmb.commonmodule.Timestamp value) {
      if (tBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        t_ = value;
      } else {
        tBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Timestamp of the last change of the value in any of 'stVal' or 'q'.
     * </pre>
     *
     * <code>.commonmodule.Timestamp t = 3;</code>
     */
    public Builder setT(
        openfmb.commonmodule.Timestamp.Builder builderForValue) {
      if (tBuilder_ == null) {
        t_ = builderForValue.build();
      } else {
        tBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Timestamp of the last change of the value in any of 'stVal' or 'q'.
     * </pre>
     *
     * <code>.commonmodule.Timestamp t = 3;</code>
     */
    public Builder mergeT(openfmb.commonmodule.Timestamp value) {
      if (tBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          t_ != null &&
          t_ != openfmb.commonmodule.Timestamp.getDefaultInstance()) {
          getTBuilder().mergeFrom(value);
        } else {
          t_ = value;
        }
      } else {
        tBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Timestamp of the last change of the value in any of 'stVal' or 'q'.
     * </pre>
     *
     * <code>.commonmodule.Timestamp t = 3;</code>
     */
    public Builder clearT() {
      bitField0_ = (bitField0_ & ~0x00000004);
      t_ = null;
      if (tBuilder_ != null) {
        tBuilder_.dispose();
        tBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Timestamp of the last change of the value in any of 'stVal' or 'q'.
     * </pre>
     *
     * <code>.commonmodule.Timestamp t = 3;</code>
     */
    public openfmb.commonmodule.Timestamp.Builder getTBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getTFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Timestamp of the last change of the value in any of 'stVal' or 'q'.
     * </pre>
     *
     * <code>.commonmodule.Timestamp t = 3;</code>
     */
    public openfmb.commonmodule.TimestampOrBuilder getTOrBuilder() {
      if (tBuilder_ != null) {
        return tBuilder_.getMessageOrBuilder();
      } else {
        return t_ == null ?
            openfmb.commonmodule.Timestamp.getDefaultInstance() : t_;
      }
    }
    /**
     * <pre>
     * Timestamp of the last change of the value in any of 'stVal' or 'q'.
     * </pre>
     *
     * <code>.commonmodule.Timestamp t = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Timestamp, openfmb.commonmodule.Timestamp.Builder, openfmb.commonmodule.TimestampOrBuilder> 
        getTFieldBuilder() {
      if (tBuilder_ == null) {
        tBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Timestamp, openfmb.commonmodule.Timestamp.Builder, openfmb.commonmodule.TimestampOrBuilder>(
                getT(),
                getParentForChildren(),
                isClean());
        t_ = null;
      }
      return tBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.VSS)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.VSS)
  private static final openfmb.commonmodule.VSS DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.VSS();
  }

  public static openfmb.commonmodule.VSS getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<VSS>
      PARSER = new com.google.protobuf.AbstractParser<VSS>() {
    @java.lang.Override
    public VSS parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<VSS> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<VSS> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.VSS getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

